* ..... txt-o-matic
* .....
* ..... written by Tom Leylan, CIS: 74216,3212
* ..... from an original idea by Tom Rombouts
* .....
* ..... compile : clipper txt -l
* ..... link    : plink86 fi txt lib clipper, extend ;
* .....
* ..... BTW, there is no font[0] element, so if you have either
* .....      chr(0)'s or chr(128)'s in your textfile you will receive
* .....      an error message (add a test for them if you like)

* ..... parameters
parameters l_parm

* ..... clear screen
clear

* ..... if no parameter
if pcount() = 0
  ?
  ? "Usage : TXT txtfile"
  ?
  ? " Note : txtfile limited to 64K"
  ?
  return
else
  * ..... if file doesn't exist
  if !file(l_parm)
    ?
    ? "Usage : TXT txtfile"
    ?
    ? "Input file not found..."
    ?
    return
  * ..... endif file doesn't exist
  endif !file(l_parm)
* ..... endif no parameter
endif pcount() = 0

* ..... set environment
set cursor off

* ..... private
private l_file, l_size, l_text
* ..... open file
l_file = fopen(l_parm, 0)
l_size = fseek(l_file, 0, 2)
fseek(l_file, 0)
* ..... read file
l_text = upper(freadstr(l_file, min(l_size, 65000))) + space(10)
l_size = l_size + 10
* ..... close file
fclose(l_text)

* ..... init font
init_font()

* ..... private
private k_flow, k_exit
* ..... init keys
k_flow = 32
k_exit = 27

* ..... private
private l_flow
* ..... init direction var
l_flow = 1

* ..... private
private l_cnt, l_char, l_key, l_bits
* ..... init char counter
l_cnt = 1
* ..... do while operating
do while (l_cnt <= l_size) .and. (l_cnt > 0)

  * ..... get a character
  l_char = font[asc(subs(l_text, l_cnt, 1)) % 128]

  * ..... if direction
  if l_flow > 0
    * ..... for bits = 1 to width
    for l_bits = 1 TO 8 step +1
      * ..... shift screen
      restscreen(10, 0, 16, 78, savescreen(10, 1, 16, 79))
      * .....  say a character
      @ 10, 79 say subs(l_char, l_bits     , 1)
      @ 11, 79 say subs(l_char, l_bits +  8, 1)
      @ 12, 79 say subs(l_char, l_bits + 16, 1)
      @ 13, 79 say subs(l_char, l_bits + 24, 1)
      @ 14, 79 say subs(l_char, l_bits + 32, 1)
      @ 15, 79 say subs(l_char, l_bits + 40, 1)
    * ..... next bits = 1 to width
    next l_bits = 1 TO 8 step +1
  * ..... else
  else
    * ..... for bits = 1 to width
    for l_bits = 1 TO 8 step +1
      * ..... shift screen
      restscreen(10, 1, 16, 79, savescreen(10, 0, 16, 78))
      * ..... say a character
      @ 10,  0 say subs(l_char,  9 - l_bits, 1)
      @ 11,  0 say subs(l_char, 17 - l_bits, 1)
      @ 12,  0 say subs(l_char, 25 - l_bits, 1)
      @ 13,  0 say subs(l_char, 33 - l_bits, 1)
      @ 14,  0 say subs(l_char, 41 - l_bits, 1)
      @ 15,  0 say subs(l_char, 49 - l_bits, 1)
    * ..... next bits = 1 to width
    next l_bits = 1 TO 8 step +1
  * ..... endif direction
  endif l_flow > 0

  * ..... increment character
  l_cnt = l_cnt + l_flow

  * ..... get a key
  l_key = inkey()

  * ..... do case
  do case
  * ..... case exit
  case l_key = k_exit
    l_cnt = l_size + 2
  * ..... case direction
  case l_key = k_flow
    l_cnt = l_cnt - (l_flow * 11)
    l_flow = -l_flow
  * ..... endcase
  endcase

* ..... enddo while operating
enddo while (l_cnt <= l_size) .and. (l_cnt > 0)
* ..... clear screen
clear
* ..... reset environment
set cursor on
* ..... return
return

FUNCTION init_font
* ..... public
public font[128]

* ..... init blank
font0    = "        " +;
           "        " +;
           "        " +;
           "        " +;
           "        " +;
           "        "

font[ 1] = font0
font[ 2] = font0
font[ 3] = font0
font[ 4] = font0
font[ 5] = font0
font[ 6] = font0
font[ 7] = font0
font[ 8] = font0
font[ 9] = font0
font[10] = font0
font[11] = font0
font[12] = font0
font[13] = font0
font[14] = font0
font[15] = font0
font[16] = font0
font[17] = font0
font[18] = font0
font[19] = font0
font[20] = font0
font[21] = font0
font[22] = font0
font[23] = font0
font[24] = font0
font[25] = font0
font[26] = font0
font[27] = font0
font[28] = font0
font[29] = font0
font[30] = font0
font[31] = font0
font[32] = font0

font[33] = "  Ŀ  " +;
           "     " +;
           "     " +;
           "     " +;
           "  Ŀ  " +;
           "     "

font[34] = "    " +;
           "    " +;
           "        " +;
           "        " +;
           "        " +;
           "        "

font[35] = font0
font[36] = font0
font[37] = font0
font[38] = font0
font[39] = font0
font[40] = font0
font[41] = font0
font[42] = font0
font[43] = font0

font[44] = "        " +;
           "        " +;
           "        " +;
           "        " +;
           "  Ŀ  " +;
           "     "

font[45] = "        " +;
           "        " +;
           "Ŀ" +;
           " " +;
           "        " +;
           "        "

font[46] = "        " +;
           "        " +;
           "        " +;
           "        " +;
           "  Ŀ  " +;
           "     "

font[47] = font0

font[48] = "Ŀ" +;
           "  " +;
           "  " +;
           "  " +;
           " " +;
           " "

font[49] = "Ŀ  " +;
           "    " +;
           "     " +;
           "     " +;
           "Ŀ" +;
           " "

font[50] = "Ŀ" +;
           "  " +;
           " " +;
           " " +;
           "Ŀ" +;
           " "

font[51] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           " " +;
           " "

font[52] = "ۿ Ŀ" +;
           "۳  " +;
           " " +;
           "  " +;
           "     " +;
           "     "

font[53] = "Ŀ" +;
           " " +;
           "Ŀ" +;
           "  " +;
           " " +;
           " "

font[54] = "Ŀ" +;
           " " +;
           "Ŀ" +;
           "  " +;
           " " +;
           " "

font[55] = "Ŀ" +;
           "  " +;
           "     " +;
           "     " +;
           "     " +;
           "     "

font[56] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           " " +;
           " "

font[57] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           "     " +;
           "     "

font[58] = "  Ŀ  " +;
           "     " +;
           "        " +;
           "        " +;
           "  Ŀ  " +;
           "     "

font[59] = "  Ŀ  " +;
           "     " +;
           "        " +;
           "        " +;
           "  Ŀ  " +;
           "     "

font[60] = font0

font[61] = "        " +;
           "Ŀ" +;
           " " +;
           "Ŀ" +;
           " " +;
           "        "

font[62] = font0
font[63] = font0
font[64] = font0

font[65] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           "  " +;
           "  "

font[66] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           " " +;
           " "

font[67] = "Ŀ" +;
           " " +;
           "     " +;
           "     " +;
           "Ŀ" +;
           " "

font[68] = "Ŀ" +;
           "  " +;
           "  " +;
           "  " +;
           " " +;
           " "

font[69] = "Ŀ" +;
           " " +;
           "Ŀ  " +;
           "   " +;
           "Ŀ" +;
           " "

font[70] = "Ŀ" +;
           " " +;
           "Ŀ  " +;
           "   " +;
           "     " +;
           "     "

font[71] = "Ŀ" +;
           " " +;
           " Ŀ" +;
           "  " +;
           " " +;
           " "

font[72] = "ĿĿ" +;
           "  " +;
           " " +;
           "  " +;
           "  " +;
           "  "

font[73] = "Ŀ" +;
           "  " +;
           "     " +;
           "     " +;
           "Ŀ" +;
           " "

font[74] = "Ŀ" +;
           "  " +;
           "     " +;
           "     " +;
           "   " +;
           "   "

font[75] = "Ŀ " +;
           "   " +;
           "" +;
           "  " +;
           "  " +;
           "  "

font[76] = "Ŀ    " +;
           "     " +;
           "     " +;
           "     " +;
           "Ŀ" +;
           " "

font[77] = "ĿĿ" +;
           " " +;
           " " +;
           "  " +;
           "  " +;
           "  "

font[78] = "ĿĿ" +;
           "ݳ " +;
           " " +;
           "  " +;
           "  " +;
           "  "

font[79] = "Ŀ" +;
           "  " +;
           "  " +;
           "  " +;
           " " +;
           " "

font[80] = "Ŀ" +;
           "  " +;
           " " +;
           " " +;
           "     " +;
           "     "

font[81] = "Ŀ" +;
           "  " +;
           "  " +;
           "   " +;
           " " +;
           " "

font[82] = "Ŀ" +;
           "  " +;
           " " +;
           "  " +;
           "   " +;
           "  "

font[83] = "Ŀ" +;
           " " +;
           "Ŀ" +;
           "  " +;
           " " +;
           " "

font[84] = "Ŀ" +;
           "  " +;
           "     " +;
           "     " +;
           "     " +;
           "     "

font[85] = "ĿĿ" +;
           "  " +;
           "  " +;
           "  " +;
           " " +;
           " "

font[86] = "ĿĿ" +;
           "  " +;
           "" +;
           "ݳ " +;
           "   " +;
           "   "

font[87] = "ĿĿ" +;
           "  " +;
           " " +;
           " " +;
           "  " +;
           "  "

font[88] = "ĿĿ" +;
           "" +;
           "     " +;
           "ݳ " +;
           " " +;
           "  "

font[89] = "ĿĿ" +;
           "  " +;
           " " +;
           "  " +;
           "     " +;
           "     "

font[90] = "Ŀ" +;
           " " +;
           "   " +;
           "    " +;
           "Ŀ" +;
           " "

font[92]  = font0
font[93]  = font0
font[94]  = font0
font[95]  = font0
font[96]  = font0
font[97]  = font0
font[98]  = font0
font[99]  = font0
font[100] = font0
font[101] = font0
font[102] = font0
font[103] = font0
font[104] = font0
font[105] = font0
font[106] = font0
font[107] = font0
font[108] = font0
font[109] = font0
font[110] = font0
font[111] = font0
font[112] = font0
font[113] = font0
font[114] = font0
font[115] = font0
font[116] = font0
font[117] = font0
font[118] = font0
font[119] = font0
font[120] = font0
font[121] = font0
font[122] = font0
font[123] = font0
font[124] = font0
font[125] = font0
font[126] = font0
font[127] = font0
font[128] = font0
* ..... return
return(0)

